/* 
    Automated Drink Mixer

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2007 Jason Hunt
    nulluser@gmail.com
    
    File: debug.cpp
*/
#include "core.h"

#define debug_mode 

void add_console(char * str)
{

#ifdef debug_mode
    
    static HANDLE h_console = INVALID_HANDLE_VALUE;

    if (h_console == INVALID_HANDLE_VALUE)
    {
        if (!AllocConsole()) return;
        h_console = GetStdHandle(STD_OUTPUT_HANDLE);
        
        if (h_console == INVALID_HANDLE_VALUE) return;        
    }
            
    DWORD num_out;
            
    WriteConsole(h_console, str, strlen(str), &num_out, NULL);

    debug("",str);
#endif
}


/* add a line to the debug file */
void debug(char *str1, char *str2)
{
#ifdef debug_mode

    static bool started = false;

    FILE *f;

    if (started == false)
    {
        f = fopen(LOG_FILE_NAME, "wt");
        started = true;
    }
    else
        f = fopen(LOG_FILE_NAME, "at");

    if (!f) return;

    // get system time
    SYSTEMTIME t;
    GetLocalTime(&t);

    // add line to log file
    fprintf(f, "[%d/%d/%d-%d:%02d:%02d.%03d] %s %s\n", t.wMonth, t.wDay, t.wYear, 
                                                       t.wHour, t.wMinute, t.wSecond, t.wMilliseconds,
                                                       str1, str2);
    fclose(f);
#endif
}
/* end of debug */
