/* 
    Automated Drink Mixer

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

    (C) 2007 Jason Hunt
    nulluser@gmail.com
    
    File: config.h
*/

#ifndef CONFIG_H
#define CONFIG_H

void config_load(char *config_filename);
void config_defaults( void );

extern char log_file_name[STR];
extern char serial_port[STR];
extern float arrow_width_ratio;
extern float arrow_length_ratio;
extern unsigned int drink_list_size;
extern unsigned int chars_per_line;
extern float progress_bar_width;
extern int fullscreen;
extern char bg_file[STR];
        
extern int inactive_timeout;               // Inactive seconds before database reload
extern int touchscreen_mode;               // 1 if in touchscreen mode

extern int trigger;


extern char mysql_host[STR];	// Location my mysql server
extern char mysql_user[STR];	// User
extern char mysql_pass[STR];	// Pass
extern char mysql_dbase[STR];	// Database name


extern COLORREF menu_color;    
extern COLORREF na_color;     
extern COLORREF button_color;
extern COLORREF outline_color;

#endif

