
; CC5X Version 3.1J, Copyright (c) B Knudsen Data
; C compiler for the PICmicro family
; ************  26. Nov 2007  19:58  *************

	processor  16F871
	radix  DEC

TMR0        EQU   0x01
STATUS      EQU   0x03
PORTA       EQU   0x05
TRISA       EQU   0x85
PORTB       EQU   0x06
TRISB       EQU   0x86
T0CS        EQU   5
Zero_       EQU   2
RP0         EQU   5
RP1         EQU   6
T0IE        EQU   5
GIE         EQU   7
OPTION_REG  EQU   0x81
PORTC       EQU   0x07
PORTD       EQU   0x08
PORTE       EQU   0x09
TMR1L       EQU   0x0E
TMR1H       EQU   0x0F
T2CON       EQU   0x12
RCSTA       EQU   0x18
TXREG       EQU   0x19
RCREG       EQU   0x1A
ADRESH      EQU   0x1E
ADCON0      EQU   0x1F
TRISC       EQU   0x87
TRISD       EQU   0x88
TRISE       EQU   0x89
TXSTA       EQU   0x98
SPBRG       EQU   0x99
ADRESL      EQU   0x9E
ADCON1      EQU   0x9F
PEIE        EQU   6
TMR1IF      EQU   0
TMR2IF      EQU   1
TXIF        EQU   4
RCIF        EQU   5
ADIF        EQU   6
TMR1ON      EQU   0
TMR1CS      EQU   1
ADON        EQU   0
GO          EQU   2
ADCS0       EQU   6
ADCS1       EQU   7
TMR1IE      EQU   0
TMR2IE      EQU   1
TXIE        EQU   4
RCIE        EQU   5
ADIE        EQU   6
channel_01  EQU   3
channel_02  EQU   4
channel_03  EQU   5
channel_04  EQU   4
channel_05  EQU   5
channel_06  EQU   6
channel_07  EQU   2
channel_08  EQU   1
channel_09  EQU   0
channel_10  EQU   3
channel_11  EQU   2
channel_12  EQU   1
channel_13  EQU   7
channel_14  EQU   0
analog_data EQU   0x25
wait_analog EQU   0x26
svrWREG     EQU   0x70
svrSTATUS   EQU   0x20
ch          EQU   0x21
state       EQU   0x22
channel     EQU   0x23
ch_2        EQU   0x24

	GOTO main

  ; FILE main.c
			;
			;/*
			;    Robot Controller Source
			;	(C) 2006 Jason Hunt nulluser@gmail.com
			;
			;	Version 0.01
			;
			;	16f871.h has been modified as follows:
			;	
			;	// original
			;	// #pragma chip PIC16F871, core 14, code 2048, ram 32 : 0xBF /0 /3
			;
			;	#pragma chip PIC16F871, core 14, code 0x1F00, ram 32 : 0x1FF
			;	#pragma cdata[0] = 0x0180 + 0x0A // CLRF PCLATH, prepare for code page change
			;	#pragma cdata[1] = 0 // NOP
			;	#pragma cdata[2] = 0 // NOP
			;	#pragma resetVector 3 // start address for user program
			;
			;	This reserves space for the serial bootloader.
			;*/
			;
			;#include <int16cxx.h>
			;
			;#pragma chip PIC16f871
			;#pragma config |= 0x3FF2 			// For 20 mhz ceramic resinator
			;
			;
			;#define NUM_RECV_BYTES	11			// Bytes in control packet
			;#define NUM_SEND_BYTES	20			// Bytes in telemetery packet
			;
			;#define NUM_SERVOS	6	   		    // Number of servo outputs
			;
			;#define NUM_ANALOG 8
			;
			;/* Pin Assignments */
			;
			;//#pragma bit led_0 @ PORTB.6
			;
			;#pragma bit channel_01 @ PORTD.3
			;#pragma bit channel_02 @ PORTC.4
			;#pragma bit channel_03 @ PORTC.5
			;#pragma bit channel_04 @ PORTD.4
			;#pragma bit channel_05 @ PORTD.5
			;#pragma bit channel_06 @ PORTD.6
			;#pragma bit channel_07 @ PORTD.2
			;#pragma bit channel_08 @ PORTD.1
			;#pragma bit channel_09 @ PORTD.0
			;#pragma bit channel_10 @ PORTC.3
			;#pragma bit channel_11 @ PORTC.2
			;#pragma bit channel_12 @ PORTC.1
			;#pragma bit channel_13 @ PORTD.7
			;#pragma bit channel_14 @ PORTC.0
			;
			;
			;
			;/*******************
			;** Interrupt Code **
			;*******************/
			;
			;#pragma interruptSaveCheck  n
			;#pragma origin 4
	ORG 0x0004
			;
			;
			;unsigned char analog_data;
			;
			;unsigned int wait_analog ;
			;
			;void rx_int( void );
			;
			;unsigned int t;
			;
			;
			;/* the ISR to update the servos */
			;interrupt ISR(void)
			;{
ISR
			;    int_save_registers
	MOVWF svrWREG
	SWAPF STATUS,W
	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVWF svrSTATUS
			;
			;    if (RCIF) rx_int();
	BTFSC 0x0C,RCIF
	CALL  rx_int
			;
			;	if (TMR2IF)	
	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x0C,TMR2IF
	GOTO  m002
			;	{
			;		if (wait_analog && !GO)
	MOVF  wait_analog,1
	BTFSC 0x03,Zero_
	GOTO  m001
	BTFSC 0x1F,GO
	GOTO  m001
			;		{
			;			// Reduce wait count
			;			wait_analog--;
	DECFSZ wait_analog,1
			;
			;			// Done waiting, start the converter
			;			if (wait_analog == 0) 
	GOTO  m001
			;      		{
			;                GO = 1;
	BSF   0x1F,GO
			;				TXREG = analog_data;
	MOVF  analog_data,W
	MOVWF TXREG
			;			}
			;		}
			;
			;		TMR2IF = 0; // clear flag
m001	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,TMR2IF
			;	}
			;
			;	// The analog to digital converter is done
			;    if (ADIF)
m002	BCF   0x03,RP0
	BCF   0x03,RP1
	BTFSS 0x0C,ADIF
	GOTO  m003
			;    {  
			;		analog_data = ADRESH & 0x03;
	MOVLW .3
	ANDWF ADRESH,W
	MOVWF analog_data
			;		analog_data *= 64;
	RRF   analog_data,1
	RRF   analog_data,1
	RRF   analog_data,1
	MOVLW .192
	ANDWF analog_data,1
			;		analog_data |= ADRESL;
	BSF   0x03,RP0
	MOVF  ADRESL,W
	BCF   0x03,RP0
	IORWF analog_data,1
			;
			;		TXREG = analog_data;
	MOVF  analog_data,W
	MOVWF TXREG
			;
			;    	ADCON0 = 0b.1100.0111;
	MOVLW .199
	MOVWF ADCON0
			;
			;		// Setup to wait to fire the go signal
			;
			;		wait_analog = 5;
	MOVLW .5
	MOVWF wait_analog
			;
			;		GO = 0;
	BCF   0x1F,GO
			;		ADIF = 0;		// Clear flag
	BCF   0x0C,ADIF
			;    }
			;
			;    int_restore_registers
m003	BCF   0x03,RP0
	BCF   0x03,RP1
	SWAPF svrSTATUS,W
	MOVWF STATUS
	SWAPF svrWREG,1
	SWAPF svrWREG,W
			;}
	RETFIE
			;/* end of interrupt service routine */
			;
			;/**************************
			;** End of interrupt Code **
			;**************************/
			;
			;
			;
			;void rx_int( void )
			;{
rx_int
			;    RCIF = 0;
	BCF   0x03,RP0
	BCF   0x03,RP1
	BCF   0x0C,RCIF
			;
			;    char ch = RCREG;  // Normal char for packet
	MOVF  RCREG,W
	MOVWF ch
			;
			;    unsigned char state = 0;
	CLRF  state
			;
			;    if (ch & 0x80) state = 1;
	BTFSS ch,7
	GOTO  m004
	MOVLW .1
	MOVWF state
			;
			;    unsigned char channel = ch & 0x7f;
m004	MOVLW .127
	BCF   0x03,RP0
	BCF   0x03,RP1
	ANDWF ch,W
	MOVWF channel
			;
			;    // Decode channel and set state
			;    if (channel == 1) channel_01 = state; else
	DECFSZ channel,W
	GOTO  m005
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_01
	BTFSC 0x03,Zero_
	BCF   0x08,channel_01
	GOTO  m018
			;    if (channel == 2) channel_02 = state; else
m005	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .2
	BTFSS 0x03,Zero_
	GOTO  m006
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_02
	BTFSC 0x03,Zero_
	BCF   0x07,channel_02
	GOTO  m018
			;    if (channel == 3) channel_03 = state; else
m006	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .3
	BTFSS 0x03,Zero_
	GOTO  m007
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_03
	BTFSC 0x03,Zero_
	BCF   0x07,channel_03
	GOTO  m018
			;    if (channel == 4) channel_04 = state; else
m007	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .4
	BTFSS 0x03,Zero_
	GOTO  m008
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_04
	BTFSC 0x03,Zero_
	BCF   0x08,channel_04
	GOTO  m018
			;    if (channel == 5) channel_05 = state; else
m008	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .5
	BTFSS 0x03,Zero_
	GOTO  m009
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_05
	BTFSC 0x03,Zero_
	BCF   0x08,channel_05
	GOTO  m018
			;    if (channel == 6) channel_06 = state; else
m009	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .6
	BTFSS 0x03,Zero_
	GOTO  m010
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_06
	BTFSC 0x03,Zero_
	BCF   0x08,channel_06
	GOTO  m018
			;    if (channel == 7) channel_07 = state; else
m010	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .7
	BTFSS 0x03,Zero_
	GOTO  m011
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_07
	BTFSC 0x03,Zero_
	BCF   0x08,channel_07
	GOTO  m018
			;    if (channel == 8) channel_08 = state; else
m011	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .8
	BTFSS 0x03,Zero_
	GOTO  m012
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_08
	BTFSC 0x03,Zero_
	BCF   0x08,channel_08
	GOTO  m018
			;    if (channel == 9) channel_09 = state; else
m012	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .9
	BTFSS 0x03,Zero_
	GOTO  m013
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_09
	BTFSC 0x03,Zero_
	BCF   0x08,channel_09
	GOTO  m018
			;    if (channel == 10) channel_10 = state; else
m013	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .10
	BTFSS 0x03,Zero_
	GOTO  m014
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_10
	BTFSC 0x03,Zero_
	BCF   0x07,channel_10
	GOTO  m018
			;    if (channel == 11) channel_11 = state; else
m014	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .11
	BTFSS 0x03,Zero_
	GOTO  m015
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_11
	BTFSC 0x03,Zero_
	BCF   0x07,channel_11
	GOTO  m018
			;    if (channel == 12) channel_12 = state; else
m015	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .12
	BTFSS 0x03,Zero_
	GOTO  m016
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_12
	BTFSC 0x03,Zero_
	BCF   0x07,channel_12
	GOTO  m018
			;    if (channel == 13) channel_13 = state; else
m016	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .13
	BTFSS 0x03,Zero_
	GOTO  m017
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x08,channel_13
	BTFSC 0x03,Zero_
	BCF   0x08,channel_13
	GOTO  m018
			;    if (channel == 14) channel_14 = state; 
m017	BCF   0x03,RP0
	BCF   0x03,RP1
	MOVF  channel,W
	XORLW .14
	BTFSS 0x03,Zero_
	GOTO  m018
	MOVF  state,W
	BTFSS 0x03,Zero_
	BSF   0x07,channel_14
	BTFSC 0x03,Zero_
	BCF   0x07,channel_14
			;
			;} 
m018	RETURN
			;
			;
			;
			;
			;
			;
			;/***********************
			;**	Serial functions **
			;***********************/
			;
			;/* Set the serial port to  9600 8N1 */
			;void setup_serial(void)
			;{
setup_serial
			;//	SPBRG = 129;   // divisor for 9600 baud
			;	SPBRG = 64;    // divisor for 19200 baud
	MOVLW .64
	BSF   0x03,RP0
	BCF   0x03,RP1
	MOVWF SPBRG
			;
			;    TXSTA = 0b.0010.0100;  // transmitt enable, high speed
	MOVLW .36
	MOVWF TXSTA
			;	RCSTA = 0b.1001.0000; // serial enable
	MOVLW .144
	BCF   0x03,RP0
	MOVWF RCSTA
			;
			;	char ch = RCREG;  // flush buffer
	MOVF  RCREG,W
	MOVWF ch_2
			;	ch = RCREG;
	MOVF  RCREG,W
	MOVWF ch_2
			;	ch = RCREG;
	MOVF  RCREG,W
	MOVWF ch_2
			;}
	RETURN
			;/* end of setup serial */
			;
			;
			;
			;
			;/*******************
			;** Initialization **
			;*******************/
			;
			;/* system startup */
			;void startup( void )
			;{
startup
			;	PORTA = 0;			// clear ports
	BCF   0x03,RP0
	BCF   0x03,RP1
	CLRF  PORTA
			;	PORTB = 0;
	CLRF  PORTB
			;	PORTC = 0;
	CLRF  PORTC
			;	PORTD = 0;
	CLRF  PORTD
			;	PORTE = 0;
	CLRF  PORTE
			;
			;	TRISA = 0b.1111.1111;	// all inputs
	MOVLW .255
	BSF   0x03,RP0
	MOVWF TRISA
			;	TRISB = 0b.0000.0000;	
	CLRF  TRISB
			;	TRISC = 0b.1000.0000;	// bit 7 is rx
	MOVLW .128
	MOVWF TRISC
			;	TRISD = 0b.0000.0000;	
	CLRF  TRISD
			;	TRISE = 0b.0000.0000;	// E0-E2 digital in
	CLRF  TRISE
			;
			;	// clear core values before interrupts are turned on
			;
			;	// setup timer 0
			;    OPTION = 4;				// prescaler divide by 16
	MOVLW .4
	MOVWF OPTION_REG
			;	T0CS = 0;				// internel clock
	BCF   0x81,T0CS
			;    TMR0 = 0;				// clear the timer
	BCF   0x03,RP0
	CLRF  TMR0
			;    T0IE = 1;				// enable interrupt for timer 0
	BSF   0x0B,T0IE
			;
			;	// setup timer 1
			;	TMR1L = 0;			// reset timer
	CLRF  TMR1L
			;	TMR1H = 0;
	CLRF  TMR1H
			;
			;	TMR1ON = 0; 			// shut off timer to modify values
	BCF   0x10,TMR1ON
			;
			;//T1CON = 0b00110101;
			;//
			;	//T1CKPS1 = 1;			// setup prescaler
			;	//T1CKPS0 = 0;
			;	//T1OSCEN = 0;			// shut off oscillator
			;
			;	TMR1CS = 0;				// internal clock
	BCF   0x10,TMR1CS
			;	TMR1IE = 0;				// enable interrupt
	BSF   0x03,RP0
	BCF   0x8C,TMR1IE
			;
			;	TMR1ON = 1; 			// turn timer on
	BCF   0x03,RP0
	BSF   0x10,TMR1ON
			;	TMR1IF = 0;				// clear interrupt flag
	BCF   0x0C,TMR1IF
			;
			;//	TMR2 = 0xe0;
			;
			;    T2CON = 0b01111111;
	MOVLW .127
	MOVWF T2CON
			;
			;	//TMR2ON = 1;				// enable timer 2
			;	TMR2IE = 1;
	BSF   0x03,RP0
	BSF   0x8C,TMR2IE
			;
			;
			;   RCIF = 0;	// Clear receive interrupt
	BCF   0x03,RP0
	BCF   0x0C,RCIF
			;   RCIE = 1; 	// Enable receive interrupts
	BSF   0x03,RP0
	BSF   0x8C,RCIE
			;
			;   TXIF = 0;	// Clear receive interrupt
	BCF   0x03,RP0
	BCF   0x0C,TXIF
			;   TXIE = 1; 	// Enable receive interrupts
	BSF   0x03,RP0
	BSF   0x8C,TXIE
			;
			;   analog_data = 0;
	BCF   0x03,RP0
	CLRF  analog_data
			;
			;
			;	ADCON1 = 0b.1000.0000;	// RE0, 1, 2 : digital RA0,1,2,3,5 : analog
	MOVLW .128
	BSF   0x03,RP0
	MOVWF ADCON1
			;
			;
			;	ADCS1 = 1;				// Fosc/32 clocl
	BCF   0x03,RP0
	BSF   0x1F,ADCS1
			;	ADCS0 = 0;
	BCF   0x1F,ADCS0
			;	ADCON0 &= 0b.1100.0111;
	MOVLW .199
	ANDWF ADCON0,1
			;	ADON = 1;					// turn on converter
	BSF   0x1F,ADON
			;
			;    ADIF =0;
	BCF   0x0C,ADIF
			;    ADIE =1;
	BSF   0x03,RP0
	BSF   0x8C,ADIE
			;
			;	GO = 1;
	BCF   0x03,RP0
	BSF   0x1F,GO
			;	
			;    GIE = 1;				// interrupts allowed 
	BSF   0x0B,GIE
			;	PEIE = 1;				// enable periphial interrupts
	BSF   0x0B,PEIE
			;
			;wait_analog = 1;
	MOVLW .1
	MOVWF wait_analog
			;
			;    setup_serial();
	GOTO  setup_serial
			;}
			;
			;/* end of startup */
			;
			;/**************************
			;** End of Initialization **
			;**************************/
			;
			;
			;
			;
			;
			;/* main function */
			;void main ( void )
			;{
main
			;	startup();
	CALL  startup
			;
			;
			;	while (1);	// infinte loop
m019	GOTO  m019

	ORG 0x2007
	DATA 3FF2H
	END


; *** KEY INFO ***

; 0x003B  179 word(s)  8 % : rx_int
; 0x0004   55 word(s)  2 % : ISR
; 0x00EE   16 word(s)  0 % : setup_serial
; 0x00FE   63 word(s)  3 % : startup
; 0x013D    2 word(s)  0 % : main

; RAM usage: 9 bytes (6 local), 119 bytes free
; Maximum call level: 1 (+2 for interrupt)
; Total of 316 code words (15 %)
